OGRE: Ogre::GL3PlusHardwareOcclusionQuery Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::GL3PlusHardwareOcclusionQuery Class Reference

This is a class that is the base class of the query class for hardware occlusion. More...

`#include <OgreGL3PlusHardwareOcclusionQuery.h>`

Inheritance diagram for Ogre::GL3PlusHardwareOcclusionQuery:
[legend]

## Public Member Functions
| GL3PlusHardwareOcclusionQuery ()
| Default object constructor. More...
| ~GL3PlusHardwareOcclusionQuery ()
| Object destructor. More...
void | beginOcclusionQuery ()
| Starts the hardware occlusion query. More...
void | endOcclusionQuery ()
| Ends the hardware occlusion test. More...
unsigned int | getLastQuerysPixelcount () const
| Let's you get the last pixel count with out doing the hardware occlusion test. More...
bool | isStillOutstanding (void)
| Lets you know when query is done, or still be processed by the Hardware. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | pullOcclusionQuery (unsigned int *NumOfFragments)
| Pulls the hardware occlusion query. More...

## Detailed Description

This is a class that is the base class of the query class for hardware occlusion.

Author
  Lee Sandberg email: lee@a.nosp@m.bcme.nosp@m.dia.s.nosp@m.e Updated on 13/9/2005 by Tuan Kuranes email: tuan..nosp@m.kura.nosp@m.nes@f.nosp@m.ree..nosp@m.fr

## Constructor & Destructor Documentation

## ◆ GL3PlusHardwareOcclusionQuery()

Ogre::GL3PlusHardwareOcclusionQuery::GL3PlusHardwareOcclusionQuery | ( |  | ) |

Default object constructor.

## ◆ ~GL3PlusHardwareOcclusionQuery()

Ogre::GL3PlusHardwareOcclusionQuery::~GL3PlusHardwareOcclusionQuery | ( |  | ) |

Object destructor.

## Member Function Documentation

## ◆ beginOcclusionQuery()

void Ogre::GL3PlusHardwareOcclusionQuery::beginOcclusionQuery | ( |  | ) |
| virtual

Starts the hardware occlusion query.

Remarks
  Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* mOcclusionQuery; createOcclusionQuery( &mOcclusionQuery ); In the rendering loop: Draw all occluders mOcclusionQuery->startOcclusionQuery(); Draw the polygons to be tested mOcclusionQuery->endOcclusionQuery();

Results must be pulled using: UINT mNumberOfPixelsVisable; pullOcclusionQuery( &mNumberOfPixelsVisable );

Implements Ogre::HardwareOcclusionQuery.

## ◆ endOcclusionQuery()

void Ogre::GL3PlusHardwareOcclusionQuery::endOcclusionQuery | ( |  | ) |
| virtual

Ends the hardware occlusion test.

Implements Ogre::HardwareOcclusionQuery.

## ◆ getLastQuerysPixelcount()

unsigned int Ogre::HardwareOcclusionQuery::getLastQuerysPixelcount | ( |  | ) | const
| inlineinherited

Let's you get the last pixel count with out doing the hardware occlusion test.

Returns
  The last fragment count from the last test. Remarks This function won't give you new values, just the old value.

## ◆ isStillOutstanding()

bool Ogre::GL3PlusHardwareOcclusionQuery::isStillOutstanding | ( | void |  | ) |
| virtual

Lets you know when query is done, or still be processed by the Hardware.

Returns
  true if query isn't finished.

Implements Ogre::HardwareOcclusionQuery.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ pullOcclusionQuery()

bool Ogre::GL3PlusHardwareOcclusionQuery::pullOcclusionQuery | ( | unsigned int * | NumOfFragments | ) |
| virtual

Pulls the hardware occlusion query.

Note
  Waits until the query result is available; use isStillOutstanding if just want to test if the result is available.

Return values

  NumOfFragments | will get the resulting number of fragments.

Returns
  True if success or false if not.

Implements Ogre::HardwareOcclusionQuery.

The documentation for this class was generated from the following file:

- OgreGL3PlusHardwareOcclusionQuery.h